package labss.lang.il.iterators;

import java.util.Iterator;
import java.util.NoSuchElementException;

import labss.lang.il.model.ILEntity;

/**
 * @author Riccardo Solmi
 */
public class SelfIterator implements Iterator<ILEntity> {
    protected ILEntity entity;

    public SelfIterator() {
    }
    public SelfIterator(ILEntity entity) {
        this.entity = entity;
    }
    
    public boolean hasNext() {
        return entity != null;
    }

    public ILEntity next() {
    	if (entity == null)
        	throw new NoSuchElementException();

    	ILEntity result = entity;
    	entity = null;
    	return result;
    }
	
	public void remove() {
		throw new UnsupportedOperationException();
	}
}
