package labss.lang.il.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author Riccardo Solmi
 */
public class Enum<E extends EnumValue> {
	protected Map<String, E> namesMap = new HashMap<String, E>();
	protected List<E> values = new ArrayList<E>();

    public Set<String> names() {
        return Collections.unmodifiableSet(namesMap.keySet());
    }
    public List<E> values() {
        return Collections.unmodifiableList(values);
    }

    public E valueOf(int ordinal) {
        return values.get(ordinal);
    }
    public E valueOf(String name) {
        return namesMap.get(name);
    }

    public void put(E value) {
        namesMap.put(value.name, value);
    	if (value.ordinal == values.size())
    		values.add(value);
    	else {
    		for (int i=values.size(); i<=value.ordinal; i++)
    			values.add(null);
    		values.set(value.ordinal, value);
    	}
    }
}
