package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.ILEntity;
import labss.lang.il.model.ILPropertiesEnum;
import labss.lang.il.model.ILProperty;
import labss.lang.il.model.ILType;
import labss.lang.il.model.ILType5;
import labss.lang.il.model.ILTypesEnum;
import labss.lang.il.model.Statement;
import labss.lang.il.visitors.ILVisitor;

public class Assignment extends AbstractILEntity implements Statement {
	private Variable variable;

	private Expression exp;

	public Assignment(Variable variable, Expression exp) {
		this.variable = variable;
		this.exp = exp;
	}

	public Object clone() {
		Assignment s = (Assignment) super.clone();
		s.variable = (Variable) variable.clone();
		s.exp = (Expression) exp.clone();
		return s;
	}

	public ILType5 getType5() {
		return ILType5.Assignment;
	}
	public ILType getType() {
		return ILTypesEnum.tAssignment;
	}

	public void accept(ILVisitor visitor) {
		visitor.visit(this);
	}

	public Expression getExp() {
		return exp;
	}

	public void setExp(Expression exp) {
		this.exp = exp;
	}

	public Variable getVariable() {
		return variable;
	}

	public void setVariable(Expression variable) {
		this.variable = (Variable) variable;
	}

	public int size() {
		return 2;
	}
	public ILEntity get(int index) {
		switch (index) {
		case 0:
			return getVariable();
		case 1:
			return getExp();
		default:
			throw new IllegalArgumentException();
		}
	}
	public void set(int index, ILEntity value) {
		switch (index) {
		case 0:
			setVariable((Variable) value);
			break;
		case 1:
			setExp((Expression) value);
			break;
		default:
			throw new IllegalArgumentException();
		}
	}
	protected int indexOf(ILProperty property) {
		switch (property.ordinal) {
		case ILPropertiesEnum.pVariable_ord:
			return 0;
		case ILPropertiesEnum.pExp_ord:
			return 1;
		default:
			throw new IllegalArgumentException();
		}
	}
}