package labss.lang.il.model.impl;

import labss.lang.il.model.ILType;
import labss.lang.il.model.ILType5;
import labss.lang.il.model.ILTypesEnum;
import labss.lang.il.visitors.ILVisitor;

/**
 * @author Riccardo Solmi
 */

public class Bool extends AbstractLiteral {
	// Singleton
	public static final Bool TRUE = new Bool(true);
	public static final Bool FALSE = new Bool(false);
	public static final Bool instance(boolean value) {
		return value ? TRUE: FALSE;
	}
	
	private boolean val;
	private Bool(boolean val) {
		this.val = val;
	}
	
	public ILType5 getType5() {
		return ILType5.Bool;
	}
	public ILType getType() {
		return ILTypesEnum.tBool;
	}

	public void accept(ILVisitor visitor) {
		visitor.visit(this);
	}
	public boolean booleanValue() {
		return val;
	}
	public void setValue(boolean value) {
		val = value;
	}
	
	public String toString() {
		return String.valueOf(val);
	}
}