package labss.lang.il.model.impl;

import labss.lang.il.model.*;

public abstract class ConditionalStatement extends AbstractILEntity implements Statement {
	protected ConditionalStatement(Expression condition, Statement trueBody) {
		this.condition = condition;
		this.trueBody = trueBody;
	}

	public Object clone() {
		ConditionalStatement s = (ConditionalStatement) super.clone();
		s.condition = (Expression) condition.clone();
		s.trueBody = (Statement) trueBody.clone();
		return s;
	}

	private Expression condition;
	public Expression getCondition() {
		return condition;
	}
	public void setCondition(Expression condition) {
		this.condition = condition;
	}

	private Statement trueBody;
	public Statement getTrueBody() {
		return trueBody;
	}
	public void setTrueBody(Statement trueBody) {
		this.trueBody = trueBody;
	}


	public int size() {
		return 2;
	}
	public ILEntity get(int index) {
		switch (index) {
		case 0:
			return getCondition();
		case 1:
			return getTrueBody();
		default:
			throw new IllegalArgumentException();
		}
	}
	public void set(int index, ILEntity value) {
		switch (index) {
		case 0:
			setCondition((Expression) value);
			break;
		case 1:
			setTrueBody((Statement) value);
			break;
		default:
			throw new IllegalArgumentException();
		}
	}
	protected int indexOf(ILProperty property) {
		switch (property.ordinal) {
		case ILPropertiesEnum.pCondition_ord:
			return 0;
		case ILPropertiesEnum.pTrueBody_ord:
			return 1;
		default:
			throw new IllegalArgumentException();
		}
	}
}
