package labss.lang.il.visitors;

import labss.lang.il.model.ILEntity;
import labss.lang.il.model.impl.Addition;
import labss.lang.il.model.impl.And;
import labss.lang.il.model.impl.Assignment;
import labss.lang.il.model.impl.Block;
import labss.lang.il.model.impl.Bool;
import labss.lang.il.model.impl.Division;
import labss.lang.il.model.impl.Equals;
import labss.lang.il.model.impl.GreaterThan;
import labss.lang.il.model.impl.IfElse;
import labss.lang.il.model.impl.If;
import labss.lang.il.model.impl.Int;
import labss.lang.il.model.impl.LessThan;
import labss.lang.il.model.impl.Multiplication;
import labss.lang.il.model.impl.Not;
import labss.lang.il.model.impl.NullExpression;
import labss.lang.il.model.impl.Empty;
import labss.lang.il.model.impl.Or;
import labss.lang.il.model.impl.Subtraction;
import labss.lang.il.model.impl.Variable;
import labss.lang.il.model.impl.While;

/**
 * @author Riccardo Solmi
 */
public class DefaultVisitor implements ILVisitor {
	public void visitDefault(ILEntity e) {
	}
	
	public void visit(Empty stm) {
		visitDefault(stm);
	}
	public void visit(NullExpression exp) {
		visitDefault(exp);
	}

	public void visit(While stm) {
		visitDefault(stm);
	}

	public void visit(If stm) {
		visitDefault(stm);
	}

	public void visit(IfElse stm) {
		visitDefault(stm);
	}

	public void visit(Assignment stm) {
		visitDefault(stm);
	}

	public void visit(Block stm) {
		visitDefault(stm);
	}

	public void visit(Bool exp) {
		visitDefault(exp);
	}

	public void visit(Int exp) {
		visitDefault(exp);
	}

	public void visit(Variable exp) {
		visitDefault(exp);
	}

	public void visit(Addition exp) {
		visitDefault(exp);
	}

	public void visit(Subtraction exp) {
		visitDefault(exp);
	}

	public void visit(Multiplication exp) {
		visitDefault(exp);
	}

	public void visit(Division exp) {
		visitDefault(exp);
	}

	public void visit(Equals exp) {
		visitDefault(exp);
	}

	public void visit(GreaterThan exp) {
		visitDefault(exp);
	}

	public void visit(LessThan exp) {
		visitDefault(exp);
	}

	public void visit(And exp) {
		visitDefault(exp);
	}

	public void visit(Or exp) {
		visitDefault(exp);
	}

	public void visit(Not exp) {
		visitDefault(exp);
	}
}
